module cache(
	wrclk,
	aclr,
	wrreq,
	wrdata,
	rdclk,
	rdreq,
	rddata,
	rdusedw
);
	input wrclk;
	input aclr;
	input wrreq;
	input [7:0] wrdata;
	input rdclk;
	input rdreq;
	output [7:0] rddata;
	output [13:0] rdusedw;
	
    dc_fifo dc_fifo (
      .rst(aclr),                  // input wire rst
      .wr_clk(wrclk),            // input wire wr_clk
      .rd_clk(rdclk),            // input wire rd_clk
      .din(wrdata),                  // input wire [7 : 0] din
      .wr_en(wrreq),              // input wire wr_en
      .rd_en(rdreq),              // input wire rd_en
      .dout(rddata),                // output wire [7 : 0] dout
      .full(),                // output wire full
      .empty(),              // output wire empty
      .rd_data_count(rdusedw),  // output wire [12 : 0] rd_data_count
      .wr_data_count( ),  // output wire [12 : 0] wr_data_count
      .wr_rst_busy(),  // output wire wr_rst_busy
      .rd_rst_busy( )  // output wire rd_rst_busy
    );
endmodule
